#include <iostream>
#include <cstdio>

int main()
{
    //std::ios::sync_with_stdio(false);
    int N, Q;
    scanf("%d %d", &N, &Q);
    int A[N+1];
    for(int i=1; i<=N; i++)scanf("%d", &A[i]);
    int L, R, res;
    for(int i=0; i<Q; i++)
    {
        scanf("%d %d", &L, &R);
        bool moze=false;
        for(int j=L; j<=R; j++) if(A[j]==0)
        {
            moze=true;
            break;
        }
        if(moze) printf("0\n");
        else printf("1\n");
    }
    return 0;
}